%function notin.m picks out those integer elements of a matrix A that are not contained in the matrix B

function [out] = notin(A,B);

%A = [1 2 3 6 7 9]; B = [2 6 7 10];

vec_A = reshape(A,prod(size(A)),1);
vec_B = reshape(B,prod(size(B)),1);

out = [];
for i = 1:length(vec_A),
    go_along = 1;
    j = 1; while ((j <= length(vec_B)) && go_along),
        if vec_B(j) == vec_A(i), 
            go_along = 0;
        end;
        j = j + 1;
    end;
    if go_along,
        if isempty(out),
            out = vec_A(i);
        else, 
            out = [out vec_A(i)];
        end;
    end;
end;


        
        