function data_mq = f_time_aggregate_data(data_m,data_q)
n = size(data_m.data,2);
data_mq.dates = data_q.dates;
data_mq.data = [];
for i=1:n
    data_mq.name_ser = data_m.name_ser;
    data_mq.data     = [ data_mq.data, NaN(size(data_q.data,1),1) ];
    % find first full quarter
    date_q_first     = data_q.dates(1,:);
    date_first       = [date_q_first(1,1), (date_q_first(1,2)-1)*3+1];     
    index_date_first = f_find_date(data_m.dates,date_first);
    % find final full quarter
    date_q_final     = data_q.dates(end,:);
    date_final       = [date_q_final(1,1), date_q_final(1,2)*3];     
    index_date_final = f_find_date(data_m.dates,date_final);
    % elim monthly obs
    series_mq = f_time_aggregate(data_m.data(index_date_first:index_date_final,i),data_m.stock_flow(1,i));
    data_mq.data(:,i) = series_mq;
end
