function [ftmcstar_out,lamstarmc_out,it_sel]= f_permute_factors_new_ext(ftmcstar,lamstarmc,ftstmed,prior)
% the same principle as in permute_factors_new except that the least correlated draws are ranked last
% sign switch is performed for the remaining factor draws separately

nf=size(lamstarmc,2);
nfmed=size(ftstmed,2);
MMC=size(lamstarmc,3);

factors=[1:nf];
it_sel=struct([]);
it_sel(1).out=[];
it_sel(1).in=[];
nm=size(ftstmed,2);

for mc=1:MMC;
    si=[];sih=[];
    co_mat=corr(ftstmed,ftmcstar(:,:,mc));
    co_max=max(abs(co_mat),[],1);
    ind_co=(abs(co_mat)==kron(ones(nm,1),co_max));
    [r c]=find(abs(co_mat)==kron(ones(size(ftstmed,2),1),co_max));
    for j=1:max(r)
        fp=c(r==j)';
        si=[si fp(find(abs(co_max(c(r==j)))==(max(co_max(c(r==j))))))];
        sih=[sih fp(find(~(abs(co_max(c(r==j)))==(max(co_max(c(r==j)))))))];
    end
    si=[si sih];

    co_sign=sign(co_mat(ind_co));

    it_sel(1).in(end+1)=mc;
    co_sign=co_sign(si);
    ind_sig=find(co_sign<0);

    lamstarmc(:,:,mc)=lamstarmc(:,si,mc);
%     if prior==2
%         betamc(:,:,mc)=betamc(:,si,mc);
%     end
    ftmcstar(:,:,mc)=ftmcstar(:,si,mc);
%     for l=1:philag
%         phistarmc(:,[1:nf]+(l-1)*nf,mc)=phistarmc(si,si+(l-1)*nf,mc);
%     end
%     sigetastarmc(:,:,mc)=sigetastarmc(si,si,mc);
%     if prior
%         rhomc(:,1,mc)=rhomc(si,1,mc);
%     end
%     taumc(:,1,mc)=taumc(si,1,mc);


    if any(ind_sig(ind_sig<=nfmed))
        ind_sigi=ind_sig(ind_sig<=nfmed);
        nk=find(~sum(factors(ones(1,length(ind_sigi)),:)==ind_sigi(:,ones(1,nf)),1));
        lamstarmc(:,ind_sigi,mc)=-lamstarmc(:,ind_sigi,mc);
        ftmcstar(:,ind_sigi,mc)=-ftmcstar(:,ind_sigi,mc);
%         for l=1:philag
%             phistarmc(nk,ind_sigi+(l-1)*nf,mc)=-phistarmc(nk,ind_sigi+(l-1)*nf,mc);
%             phistarmc(ind_sigi,nk+(l-1)*nf,mc)=-phistarmc(ind_sigi,nk+(l-1)*nf,mc);
%         end
    end
%     if  ~norm
%         lammc(:,:,mc)=lammc(:,si,mc);
%         ftmc(:,:,mc)=ftmc(:,si,mc);
%         for l=1:philag
%             phimc(:,[1:nf]+(l-1)*nf,mc)=phimc(si,si+(l-1)*nf,mc);
%         end
%         sigetamc(:,:,mc)=sigetamc(si,si,mc);
%         if any(ind_sig(ind_sig<=nfmed))
%             ind_sigi=ind_sig(ind_sig<=nfmed);
%             nk=find(~sum(factors(ones(1,length(ind_sigi)),:)==ind_sigi(:,ones(1,nf)),1));
%             lammc(:,ind_sigi,mc)=-lammc(:,ind_sigi,mc);
%             ftmc(:,ind_sigi,mc)=-ftmc(:,ind_sigi,mc);
%             for l=1:philag
%                 phimc(nk,ind_sigi+(l-1)*nf,mc)=-phimc(nk,ind_sigi+(l-1)*nf,mc);
%                 phimc(ind_sigi,nk+(l-1)*nf,mc)=-phimc(ind_sigi,nk+(l-1)*nf,mc);
%             end
%         end
%     end

end

if any(sih)
    for j=nfmed+1:nf
        ind_sigi=find(corr(ftmcstar(:,j,1),permute(ftmcstar(:,j,:),[1 3 2]))<0);
        nk=find(factors~=j);
        lamstarmc(:,j,ind_sigi)=-lamstarmc(:,j,ind_sigi);
        ftmcstar(:,j,ind_sigi)=-ftmcstar(:,j,ind_sigi);
%         for l=1:philag
%             phistarmc(nk,k+(l-1)*nf,ind_sigi)=-phistarmc(nk,k+(l-1)*nf,ind_sigi);
%             phistarmc(j,nk+(l-1)*nf,ind_sigi)=-phistarmc(j,nk+(l-1)*nf,ind_sigi);
%         end

    end

end
% end
lamstarm=median(lamstarmc(:,:,it_sel(1).in),3);
s_ind=f_checkpositivity(lamstarm);
for j=s_ind
    pid=find([1:nf]~=j);
    pcols=kron([0:philag-1]*nf,ones(1,length(pid)))+kron(ones(1,philag),pid);
    lamstarmc(:,j,:)=-lamstarmc(:,j,:);
    ftmcstar(:,j,:)=-ftmcstar(:,j,:);
%     phistarmc(pid,[0:philag-1]*nf+j,:)= -phistarmc(pid,[0:philag-1]*nf+j,:);
%     phistarmc(j,pcols,:)= -phistarmc(j,pcols,:);
end

%descending order of non-zero factor loadings
if prior>0
    [lao,si]=sort(sum(lamstarm~=0),'descend');
    lamstarmc=lamstarmc(:,si,:);
    ftmcstar=ftmcstar(:,si,:);
%     for l=1:philag
%         phistarmc(:,[1:nf]+(l-1)*nf,:)=phistarmc(si,si+(l-1)*nf,:);
%     end
%     sigetastarmc=sigetastarmc(si,si,:);
%     if any(betamc)
%         betamc=betamc(:,si,:);
%     end
%     if any(rhomc)
%         rhomc=rhomc(si,1,:);
%     end
%     taumc(:,1,mc)=taumc(si,1,mc);
end

lamstarmc_out=lamstarmc;
ftmcstar_out=ftmcstar;

end