% prepare paths, dgps and model specifications

% path
base_dir1 = '.\';
addpath(genpath(base_dir1));
folder_path=[base_dir1,'src\']; addpath(folder_path);
folder_path=[base_dir1,'src\iris\']; addpath(folder_path);
folder_path=[base_dir1,'src\lesage\']; addpath(folder_path); 
folder_path=[base_dir1,'srcnew\']; addpath(folder_path); 
folder_path=[base_dir1,'srcfacmod\']; addpath(folder_path);
base_dir = base_dir1;

% generate folder and for results
folder='.\data\';
if not(exist(folder,'dir')==7)
    mkdir(folder);
end
folder='.\results\';
if not(exist(folder,'dir')==7)
    mkdir(folder);
end

% number of replications
n_rep=65;

% dgp
s0_dgp_vec=[0.1,0.5,0.9]; % degrees of sparsity in dgp
N_sim=60;
T_sim=100;
T0_sim=100;
nf_sim=2; % no factors
philag_sim=1;
psilag_sim=0;
nf_vec=2; % take only models with two factors (here no vector)
nf_maxindex=size(nf_vec,2); 

% prior for estimation
prior_est_vec=[0,1,2]; % prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;
n_prior=size(prior_est_vec,2);
