function fd = f_pmultnormlog(y,prm,prv)

% auswerten einer multivariaten normalverteilung fuer verscheidene argumente mit verschiedenen
% parametern - ergebnis: log des funktionswertes

%input: 
% beta ... spaltenvektor (1 argument)
%      ... matrix; anzahl der spalten = verschiedene argumente; die spalten  enthalten
%                  die argumante
% prm ... mean - spaltenvektor
% prv ... varianz

%output: funktionswerte ... 1 zeile


fln = -0.5*log(prv)-0.5*log(2*pi);
flg = -0.5*(y-prm).^2./prv;
fd = fln+flg;

