function [ftstar_all,lamspar,lam,tau]=f_simparlamnormal(y,ft,lam_old,psi,sigeps,sigeta_old,tau_old,psilag,tau0,utz)

N=size(y,2);
nf=size(ft,2);

lamspar=zeros(N,nf);
lam=zeros(N,nf);
tau=zeros(nf,1);
taup=tau0;
tau_old=diag(tau_old);

[ve,va]=eig(sigeta_old);
H_old=ve*sqrt(va)*ve';
HI_old=ve*inv(sqrt(va))*ve';
ftstar_all=(HI_old*ft')';
ftstar=ftstar_all(psilag+1:end,:,ones(1,N));
lamspar_old=lam_old*H_old;
% for j=1:philag;
%     phistar(:,(j-1)*nf+1:j*nf)= HI_old*phi_old(:,(j-1)*nf+1:j*nf)*H_old;
% end

if any(psilag);
    for j=1:nf;
    ftstar(:,j,:)=f_lagtrans_ind(squeeze(ftstar_all(:,j,ones(1,N))),psilag,psi); 
    end
end

T=min(size(ftstar,1),size(y,1));
y=y(end-T+1:end,:);
ftstar=ftstar(end-T+1:end,:,:);

%sample lamspar_ij across i

for j=1:N;    
    xstar=y(:,j);
    la_sim=1:(~utz*nf+utz*min(j,nf));
    Mi=inv(ftstar(:,la_sim,j)'*ftstar(:,la_sim,j)./sigeps(j)+ inv(tau_old(la_sim,la_sim)));
    mi=Mi*(ftstar(:,la_sim,j)'*xstar./sigeps(j));
    lamspar(j,la_sim)=mi'+randn(1,length(la_sim))*chol(Mi);
    % lamspar_old(j,:)=lamspar(j,:);
end   
taup=taup+[~utz*kron(ones(nf,1),0.5*N)+utz*0.5*[N:-1:N-(nf-1)]' 0.5*sum(lamspar.^2,1)'];
tau=1./gamrnd(taup(:,1),1./taup(:,2));

% [ve,va]=eig(lamspar'*lamspar);
% H=ve*sqrt(va)*ve';
% HI=ve*inv(sqrt(va))*ve';
% 
% lam=lamspar*HI;
% sigeta=H*H';
% 
% for j=1:philag;
%     phi(:,(j-1)*nf+1:j*nf)= H*phistar(:,(j-1)*nf+1:j*nf)*HI;
% end
%     
    
end    
